#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define N150 150

#define NX 3000
#define NY 3000

int main(int argc, char *argv[]){
  FILE	*fp;
  char outputfilename[N150];
  int	i, j, tmp_cn, cn;
  float	tmp_rad, tmp_tbb, rad[1024], tbb[1024];
  unsigned short *data_all;
  float *dt;

  if(argc!=3){
     fprintf(stderr,"Usage: count2tbb.c inputfilename converttable\n");
     exit(1);
  }

  data_all=(unsigned short*)malloc(2*NX*NY);
  dt=(float*)malloc(4*NX*NY);

  if((fp=fopen(argv[1],"r"))==NULL){
     fprintf(stderr,"*** inputfile (%s) cannot open ***\n",argv[1]);
     exit(1);
  }
  fread(data_all,sizeof(unsigned short),NX*NY,fp);
  fclose(fp);

  if((fp=fopen(argv[2],"r"))==NULL){
     fprintf(stderr,"*** convert file (%s) cannot open ***\n",argv[2]);
     exit(1);
  }
  for(i=0;i<1024;i++){
     fscanf(fp,"%d %f %f",&tmp_cn, &tmp_rad, &tmp_tbb);
     rad[i]=tmp_rad;  tbb[i]=tmp_tbb;
//     printf("%d\t%f\t%f\n",tmp_cn,rad[i],tbb[i]);
  }
  fclose(fp);


  for(i=0;i<NY;i++){
  for(j=0;j<NX;j++){
     cn=(int)data_all[NX*i+j];
     dt[NX*i+j]=tbb[cn];
  }}

  sprintf(outputfilename,"tbb_%s",argv[1]);
  fp=fopen(outputfilename,"w");
  fwrite(dt,sizeof(float),NX*NY,fp);
  fclose(fp);

  free(dt);  free(data_all);
  return 0;
}
